• 欢迎访问web前端中文站,JavaScript,CSS3,HTML5,web前端demo
  • 如果您觉得本站非常有看点,那么赶紧使用Ctrl+D 收藏web前端中文站吧

Shell Bash 的错误处理

JAVA web前端中文站 2年前 (2017-11-18) 1777次浏览 已收录 0个评论

所有语言都有异常处理机制,shell 也不例外。java 的异常处理,经常被人们吐槽,那么 shell 的异常处理机制又是怎样的呢?通过本文我们一起来看看。

更多精彩内容请看 web 前端中文站
http://www.lisa33xiaoq.net 可按 Ctrl + D 进行收藏

如果脚本里面有运行失败的命令(返回值非 0),Bash 默认会继续执行后面的命令。

 #!/usr/bin/env bash  foo echo bar

上面脚本中,foo 是一个不存在的命令,执行时会报错。但是,Bash 会忽略这个错误,继续往下执行。

 $ bash script.sh script.sh:行 3: foo: 未找到命令 bar

可以看到,Bash 只是显示有错误,并没有终止执行。

这种行为很不利于脚本安全和除错。实际开发中,如果某个命令失败,往往需要脚本停止执行,防止错误累积。这时,一般采用下面的写法。

 command || exit 1

上面的写法表示只要command有非零返回值,脚本就会停止执行。

如果停止执行之前需要完成多个操作,就要采用下面三种写法。

 # 写法一 command || { echo "command failed"; exit 1; }  
 # 写法二 if ! command; then echo "command failed"; exit 1; fi  
 # 写法三 command if [ "$?" -ne 0 ]; then echo "command failed"; exit 1; 
 fi

另外,除了停止执行,还有一种情况。如果两个命令有继承关系,只有第一个命令成功了,才能继续执行第二个命令,那么就要采用下面的写法。

 command1 && command2

web 前端中文站点评:

学习了 shell 的异常处理机制后,或许你会想了解更多有关 shell 的知识,具体扩展可参考《SHELL BASH 脚本 SET -E 教程》和《SHELL BASH 脚本 SET -O PIPEFAIL 教程

【注:本文源自网络文章资源,由站长整理发布】


web 前端中文站 , 版权所有丨如未注明 , 均为原创丨本网站采用BY-NC-SA协议进行授权
转载请注明原文链接:Shell Bash 的错误处理
喜欢 (0)
发表我的评论
取消评论
表情 贴图 加粗 删除线 居中 斜体 签到

Hi,您需要填写昵称和邮箱!

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址